import json
from django.core.management.base import BaseCommand
from macrociclos.models import Macrociclo


class Command(BaseCommand):
    help = "Importa macrociclos desde un archivo JSON"

    def add_arguments(self, parser):
        parser.add_argument('archivo_json', type=str, help="Ruta del archivo JSON")

    def handle(self, *args, **kwargs):
        archivo_json = kwargs['archivo_json']

        try:
            with open(archivo_json, 'r', encoding='utf-8') as file:
                datos = json.load(file)

            self.stdout.write(self.style.WARNING(f"\nSe encontraron {len(datos)} macrociclos en el archivo '{archivo_json}'."))
            confirmar = input("¿Deseas continuar con la importación? (s/n): ").strip().lower()

            if confirmar != 's':
                self.stdout.write(self.style.ERROR("Importación cancelada."))
                return

            macrociclos_creados = 0
            for macrociclo_data in datos:
                creado = Macrociclo.objects.create(
                    nombre=macrociclo_data['nombre'],
                    tipo=macrociclo_data['tipo'],
                    desde=macrociclo_data['desde'],
                    hasta=macrociclo_data['hasta']
                    deportista=macrociclo_data['deportista']
                    entrenador=macrociclo_data['entrenador']
                )
                if creado:
                    macrociclos_creados += 1

            self.stdout.write(self.style.SUCCESS(f'Se importaron {macrociclos_creados} macrociclos correctamente.'))

        except FileNotFoundError:
            self.stderr.write(self.style.ERROR(f"El archivo {archivo_json} no se encontró."))
        except json.JSONDecodeError:
            self.stderr.write(self.style.ERROR("Error al leer el archivo JSON. Asegúrate de que el formato sea correcto."))
